/***
 * Excerpted from "Google Web Toolkit",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/ebgwt for more book information.
***/
package com.xyz.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.History;
import com.google.gwt.user.client.HistoryListener;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;


public class HistoryExample implements EntryPoint, HistoryListener {

   private Label lbl = new Label();

   public void onModuleLoad() {
      // Create three hyperlinks that change the application's
      // history.
      Hyperlink link0 = new Hyperlink("link to foo", "foo");
      Hyperlink link1 = new Hyperlink("link to bar", "bar");
      Hyperlink link2 = new Hyperlink("link to baz", "baz");

      // If the application starts with no history token, start it
      // off in the 'baz' state.
      String initToken = History.getToken();
      if (initToken.length() == 0)
         initToken = "baz";

      // onHistoryChanged() is not called when the application first
      // runs. Call it now in order to reflect the initial state.
      onHistoryChanged(initToken);

      // Add widgets to the root panel.
      Panel panel = new VerticalPanel();
      panel.add(lbl);
      panel.add(link0);
      panel.add(link1);
      panel.add(link2);
      RootPanel.get().add(panel);

      // Add history listener
      History.addHistoryListener(this);
   }

   public void onHistoryChanged(String historyToken) {
      // This method is called whenever the application's history
      // changes. Set the label to reflect the current token.
      lbl.setText("The current history token is: " + historyToken);
   }
}

