/***
 * Excerpted from "Google Web Toolkit",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/ebgwt for more book information.
***/
package com.xyz.client;


public class J2JS {
   /** Pass a Java numeric primitive */
   public static void testJ2JSNumeric() {
      int x = 42;
      jsNumeric(x);
   }

   private static native void jsNumeric(int x) /*-{
    $wnd.alert("x is " + x);
    }-*/;

   /** Pass a Java String */
   public static void testJ2JSString() {
      String s = "my string";
      jsString(s);
   }

   private static native void jsString(String s) /*-{
    $wnd.alert("s is " + s);
    }-*/;

   /** Pass a boolean */
   public static void testJ2JSBoolean() {
      boolean b = true;
      jsBoolean(b);
   }

   private static native void jsBoolean(boolean b) /*-{
    $wnd.alert("b is " + b);
    }-*/;

   /** Pass an arbitrary Java Object */
   public static void testJ2JSObject() {
      MyJavaObject obj = new MyJavaObject();
      jsObject(obj);
   }

   private static native void jsObject(MyJavaObject obj) /*-{
    $wnd.alert("Calling getText(): " + obj.@MyJavaObject::getTextAt(I)(3));      
    }-*/;
}

