/***
 * Excerpted from "Google Web Toolkit",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/ebgwt for more book information.
***/
package com.xyz.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */

public class RpcExample implements EntryPoint, ClickListener {
   private Button button = new Button("Click me");
   private HTML label = new HTML();

   public void onModuleLoad() {
      button.addClickListener(this);

      RootPanel.get("slot1").add(button);
      RootPanel.get("slot2").add(label);
   }

   // ...
   

   
   private void updatePrices(String[] symbols, double[] prices) {
      String html = "";
      for (int i = 0; i < symbols.length; i++) {
         html += symbols[i] + ": " + prices[i] + "<br/>";
      }
      label.setHTML(html);
   }

   
   
   private String[] symbols = { "GOOG", "MSFT", "SUNW" };

   public void onClick(Widget sender) {
      // (1) Create the client proxy. Note that although you are
      // creating the service interface proper, you cast the
      // result to the async version of the interface. The cast
      // is always safe because the generated proxy implements
      // the async interface automatically.
      StockServiceAsync service = (StockServiceAsync) GWT
            .create(StockService.class);

      // (2) Specify the URL at which our service implementation is
      // running. Note that the target URL must reside on the same
      // domain and port from which the host page was served.
      ServiceDefTarget endpoint = (ServiceDefTarget) service;
      endpoint.setServiceEntryPoint(GWT.getModuleBaseURL() + "prices");

      // (3) Create an async callback to handle the result.
      AsyncCallback callback = new AsyncCallback() {
         public void onSuccess(Object result) {
            double[] prices = (double[]) result;
            updatePrices(symbols, prices);
         }

         public void onFailure(Throwable caught) {
            // do some UI stuff to show failure
         }
      };

      // (4) Make the call. Control flow will continue immediately
      // and later 'callback' will be invoked when the RPC completes.
      service.getPrices(symbols, callback);
   }
   
   
}

