/***
 * Excerpted from "Google Web Toolkit",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/ebgwt for more book information.
***/
package com.xyz.server;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.xyz.client.StockService;


public class StockServiceImpl extends RemoteServiceServlet
      implements StockService {
   

   
   private double price = 400.0;

   private synchronized double getPrice(String symbol) {
      // Real code would retrieve the prices here
      return price++;
   }

   

   
   public double[] getPrices(String[] symbols) {
      double[] result = new double[symbols.length];
      for (int i = 0; i < symbols.length; i++) {
         result[i] = getPrice(symbols[i]);
      }
      return result;
   }
}

